%%
%% $Id: intro.tex,v 1.2 2003-09-27 09:14:14 baurma Exp $
%% $Makefile$
%%

\chapter{Introduction}

One advantage of the Java programming language environment is
the possibility to deploy entire Java applications over the network.
In an earlier stage of development, the \JNuke class loader was only
able to load single class files from disk. This document describes how
the \JNuke framework was extended with the possibility to load
a single Java class files from a JAR archive.


\section{JAR Files and Data Compression}

The JAR file format is based on the ZIP file format, introduced
by the PKWARE \cite{pkware} PKZIP utility. A ZIP file can store files, directories,
as well as special files (Named pipes, etc.). We therefore refer to
elements of a ZIP file as entries. While the ZIP file format supports
various compression methods, JAR files use only a subset of them,
as shown in Figure \ref{fig:zipcompmeth}.

\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlcc}
\textbf{ID} & \textbf{Method} & \textbf{ZIP} & \textbf{JAR} \\
\hline
 0 & Stored (no compression) & $\times$ & $\times$ \\
 1 & Shrink                  & $\times$ & --- \\
 2 & Reduce                  & $\times$ & --- \\
 3 & Reduce                  & $\times$ & --- \\
 4 & Reduce                  & $\times$ & --- \\
 5 & Reduce                  & $\times$ & --- \\
 6 & Implode                 & $\times$ & --- \\
 7 & Tokenize                & $\times$ & --- \\
 8 & Deflate                 & $\times$ & $\times$ \\
 9 & Enhanced Deflate        & $\times$ & --- \\
10 & DCL Implode             & $\times$ & --- 
\end{tabular}
\caption{Compression methods in ZIP and JAR files}
\end{center}
\label{fig:zipcompmeth}
\end{figure}


Decompression of compressed entries is done using the ZLIB library.

\section{Overall architecture}

JNukeJarFile represents an entire JAR file.
Each JAR file consists of a vector JarEntry objects.

\subsection{Compression plugins}

The JAR facility supports decompression through plug-ins.
Currently, there are two working plugins for the JAR compression
methods

\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlll}
 ID & Compression Method & Handler & Status \\
  0 & Stored (no compression) & unstore.c  & Full support \\
  1 & Shrink                  & unshrink.c & Stub returning error code \\
2-5 & Reduce                  & unreduce.c & Partial implementation (alpha stage) \\
  6 & Implode          & unimplode.c & Stub returning error code \\
  7 & Tokenize         & ---         & Unsupported \\
  8 & Deflate          & undeflate.c & Full support through ZLIB library \\
  9 & Enhanced Deflate & ---         & Unsupported \\
 10 & DCL Implode      & ---         & Unsupported \\
\end{tabular}
\caption{Compression methods and implementation state}
\end{center}
\end{figure}

\subsubsection{Decompression plugin interface}

A decompression plugins is required to implement a method of the
following signature:

\code{
char *
JNukeJar\_methname ( \\
\tab	const JNukeObj * this, \\
\tab	int *status \\
)
}

The parameters are as follows:

\begin{description}
\ttitem{this}
	A reference to a JNukeJarEntry object containing the
	entity to be decompressed is passed to the
	plugin.
\ttitem{status}
	The plugin may return a status code to the caller.
	All status codes are defined in jar/jar.h as 
	constants.
	See Figure \ref{fig:validstatuscodes} for a list
	of valid status codes.
\ttitem{Return value}
\end{description}

\begin{figure}
\begin{center}
\begin{tabular}{ll}
Status code & Description \\
\hline
JAR\_DECOMPRESS\_SUCCESS          & Decompression was successful \\
ERR\_JAR\_DECOMPRESS\_UNSUPPORTED & Decompression method not supported \\
ERR\_JAR\_DECOMPRESS\_CHECKSUM    & Checksum error \\
ERR\_JAR\_DECOMPRESS\_OTHER       & Other / Unknown error \\
\end{tabular}
\caption{Valid status codes for decompression plugins}
\end{center}
\label{fig:validstatuscodes}
\end{figure}

Upon invocation of the interface method, the plugin should call
the method \texttt{JNukeJarEntry\_getCompressedSize} to obtain the
size of the compressed data buffer. The compressed data itself can
be obtained using the method \texttt{JNukeJarEntry\_getCompressedData}.

As JAR files store the size of the decompressed size, this information
can be used to pre-allocate a buffer for the decompression task. The
original file size can be obtained by calling 
\texttt{JNukeJarEntry\_getDecompressedSize}. The plugin is expected
to allocate its own buffer for the decompressed data and is required
to return a pointer to this buffer.

Once the compressed data and the file sizes are known, the plugin should
perform its decompression task. If the data could be compressed, the
status code should be set to JAR\_DECOMPRESS\_SUCCESS and the buffer
with the decompressed data should be returned.

If an error occurred, the plugin should return NULL and set an appropriate
error code. If buffers were allocated, the plugin should free them 
beforehand.


\section{Interaction of JAR library with the class loader}

The class loader was extended with a method to load a class
from a jar file. It has the following interface:

\code{
JNukeObj * \\
JNukeClassLoader\_loadClassInJarFile ( \\
\tab	JNukeObj * this, \\
\tab	const char * classFileName, \\
\tab	const char * jarFileName \\
)
}

The class pool and the class path objects were adapted to 
be able to locate class files in jar archives. It is therefore
possible to add a JAR file to the global class path and
load it directly using the default
JNukeClassPool\_loadClassInClassPath method

\section{Error handling}

\section{Code Examples}

